
/*
 * adc.S
 *
 *  Author: razvan
 */ 

 #include <avr/io.h>
 #include "defines.h"


 // For a prescale of 16, this takes 220 clock cycles
 .macro READ_ADC high:req, low:req
    // Clear ready flag
    lds TEMP_REGISTER_ONE, ADCSRA                   // 2 clock cycles
    // Clear the data ready flag
    // Enable a conversion
    ori TEMP_REGISTER_ONE, (1 << ADSC) | (~(1 << ADIF))// 1 clock cycle
    // Start a conversion
    sts ADCSRA, TEMP_REGISTER_ONE                   // 2 clock cycles
1:  lds TEMP_REGISTER_ONE, ADCSRA                   // 2 clock cycles
    sbrs TEMP_REGISTER_ONE, ADIF                    // 1(2) clock cycle
    rjmp 1b                                         // 2 clock cycles
    lds \low, ADCL                                  // 2 clock cycles
    lds \high, ADCH                                 // 2 clock cycles
    and \high, 3 // Keep Last two bits              // 1 clock cycle
 .endm
